/*
 * Copyright  2005 Vyacheslav Anikin. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* $Id: calcfreq.c,v 1.5 2005/11/25 21:14:04 ghos Exp $ */

#include <stdio.h>
#include "cptaba.h"

int main(int argc, char **argv)
{
	if (argc < 2) {
		printf("You must specify file to analize\n");
		return 1;
	}
	int ts = codepage[2].cp_size;
	u_char *cp_data = codepage[2].cp_data;

	int freq[256];

	bzero(freq, sizeof(freq));
	int c;
	int size = 0;

	FILE *f = fopen(argv[1], "r");

	while ((c = fgetc(f)) != EOF) {
		++freq[c];
		++size;
	}

	int i;
	for (i = 0; i < ts; i++) {
		printf("%.8f, ", freq[cp_data[i]] / (float)size);
	}
	printf("\n");
	return 0;
}
